package enumerations;

/**
 * For representing states of an elevator user, as specified in {@link interfaces.ElevatorUserSpecification}: 
 * <ul> 
 * <li> {@link #ARRIVED_AT_FLOOR} </li>
 * <li> {@link #WAITING_AT_FLOOR} </li>
 * <li> {@link #IN_ELEVATOR} </li> 
 * <li> {@link #SERVICED} </li>
 * </ul>
 * @author jpaulgibson
 */
public enum UserState {
	
	/**
	 * The initial state of the elevator user when they arrive at a floor in order to use the elevator
	 */
	ARRIVED_AT_FLOOR, 
	
	/**
	 * After making a request for the elevator to come to the floor, the user is waiting at the floor
	 */
	WAITING_AT_FLOOR, 
	
	/**
	 * When the user has entered the elevator and pressed the destination floor button inside the elevator
	 */
	IN_ELEVATOR, 
	
	/**
	 * When the user has left the elevator
	 */
	 SERVICED

}
