package interfaces;

/**
 * If an elevator has doors 
 * then this interface requires the states of the doors at each floor to be visible
 * @author jpaulgibson
 *
 */
public interface ElevatorWithDoorsSpecification extends ElevatorSpecification{
	
	/**
	 * Is the door open at the specified floor?
	 * @param floor being checked
	 * @return if the door is open at the specified floor
	 */
	public boolean doorOpenAtFloor(int floor);

}
