package models.elevatorButtons;

import abstractions.LockableFloorButtonsInElevator;

/**
 * This subclass specialisation of the {@link abstractions.LockableFloorButtonsInElevator}
 * corresponds to {@link enumerations.SecurityType#OPTION1}
 * @author jpaulgibson
 */
public class LockableFloorButtonsInElevator_Option1 extends LockableFloorButtonsInElevator{

	public LockableFloorButtonsInElevator_Option1(int numberOfFloors,boolean[] lockableFloor) {
		super(numberOfFloors, lockableFloor);

	}

	/**
	 * Lock a floor only if it is lockable. <br>
	 * Our policy is that when we lock a floor then if it has been previously unlocked in order to
	 * record a floor request, then the floor request is maintained.
	 */
	@Override
    public  void lock (int floor){
    	
    	if (lockableFloor[floor] ) lockedFloor[floor] = true;
    }

}
