package regression_tests_WithDoors;

import interfaces.LogicUnitForElevatorSpecification;
import interfaces.ElevatorSpecification;

import org.junit.After;
import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;

import validation_tests.use_case10.Validation_Elevator_UseCase10;

public abstract class JUnit_WithDoors {
	
	
LogicUnitForElevatorSpecification controllerUnderTest1, controllerUnderTest2;
ElevatorSpecification withoutDoors;
ElevatorSpecification withDoors;
	

	@Before
	public  abstract void setUp() throws Exception;
		
		
	
	@After
	public void tearDown() throws Exception {
		controllerUnderTest1 = null;
		controllerUnderTest2 = null;
		withoutDoors =null;
		withDoors = null;
	}
	
	
	/**
	 * The state of the 2 objects under test must be the same after test set up <br>
	 */
	@Test
	public void test_SetUp(){
		
		Assert.assertEquals(withoutDoors.currentDirection(), withDoors.currentDirection());
		Assert.assertEquals(withoutDoors.currentFloor(), withDoors.currentFloor());
		
		for (int floor =0; floor< Validation_Elevator_UseCase10.MINIMUM_NUMBER_OF_FLOORS; floor++){
		   Assert.assertEquals(withoutDoors.floorPressedInElevator(floor), withDoors.floorPressedInElevator(floor));
		   Assert.assertEquals(withoutDoors.downPressedAtFloor(floor), withDoors.downPressedAtFloor(floor));
		   Assert.assertEquals(withoutDoors.upPressedAtFloor(floor), withDoors.upPressedAtFloor(floor));
		}
		
		
	}

	/**
	 * regression test : the use case must end up with the final states of the elevators being the same <br>
	 */
	@Test
	public void regression(){
		
		
		Validation_Elevator_UseCase10.validate(withDoors);
		Validation_Elevator_UseCase10.validate(withoutDoors);
		
		Assert.assertEquals(withoutDoors.currentDirection(), withDoors.currentDirection());
		Assert.assertEquals(withoutDoors.currentFloor(), withDoors.currentFloor());
		
		for (int floor =0; floor< Validation_Elevator_UseCase10.MINIMUM_NUMBER_OF_FLOORS; floor++){
			   Assert.assertEquals(withoutDoors.floorPressedInElevator(floor), withDoors.floorPressedInElevator(floor));
			   Assert.assertEquals(withoutDoors.downPressedAtFloor(floor), withDoors.downPressedAtFloor(floor));
			   Assert.assertEquals(withoutDoors.upPressedAtFloor(floor), withDoors.upPressedAtFloor(floor));
			}
		
	}

}
