package unit_tests.elevators.unitTestAbstractions_elevators;

import interfaces.ElevatorSpecification;

import org.junit.After;
import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;

import enumerations.DirectionState;
import validation_tests.use_case10.Validation_Elevator_UseCase10;

public abstract class JUnit_ElevatorSpecification {
	
	protected ElevatorSpecification elevatorUnderTest;
	
	@Before
	public  abstract void setUp() throws Exception;
		
		
	
	@After
	public void tearDown() throws Exception {
		elevatorUnderTest = null;
	}
	
	
	/**
	 * The initial state of the test case <br>
	 */
	@Test
	public void test_SetUp(){
		
		Assert.assertEquals(elevatorUnderTest.currentDirection(), DirectionState.STAY);
		Assert.assertEquals(elevatorUnderTest.currentFloor(), 0);
		
		for (int floor =0; floor< Validation_Elevator_UseCase10.MINIMUM_NUMBER_OF_FLOORS; floor++){
		   Assert.assertFalse(elevatorUnderTest.floorPressedInElevator(floor));
		   Assert.assertFalse(elevatorUnderTest.downPressedAtFloor(floor));
		   Assert.assertFalse(elevatorUnderTest.upPressedAtFloor(floor));
		}
	
	}




}
