package validation_tests.use_case1;

import interfaces.ElevatorSpecification;
import interfaces.LogicUnitForElevatorSpecification;
import enumerations.LogicType;
import enumerations.SecurityType;
import factoriesSPL.ElevatorFactory;
import factoriesSPL.LogicUnitFactory;
import tools.DateHeader;

public class Validation_UseCase1_Elevator_Smart {
	
	
	/**
	 * The time between elevator updates as decided by the logic unit.<br>
	 * This will also govern the rate at which the elevator state updates are displayed on the console during
	 * the execution of the use case scenario.
	 */
	public static final int DELAY_TIME = 1000; // 1000 ms = 1 second
	
	// The configuration of the elevator to be tested against the scenario
	
	public static final boolean DOORS = false;
	
	public static final int NUMBER_OF_FLOORS = 6;
	
	public static SecurityType SECURITY_TYPE = SecurityType.NONE;
	
	public static LogicType LOGIC_TYPE = LogicType.SMART;
	
	
	public static Elevator_UseCaseScenario1 useCase;
	
	public static void main(String[] args) {
		
		 System.out.println(DateHeader.dateString());
		
		// Make a smart logic unit, not yet bound to (installed in) a particular elevator
	    LogicUnitForElevatorSpecification logicUnit = LogicUnitFactory.makeLogicUnit(LOGIC_TYPE);
	    
		//Make an elevator without doors, not yet bound to a particular controller
		ElevatorSpecification elevator = 
				ElevatorFactory.makeElevator(DOORS, NUMBER_OF_FLOORS, LOGIC_TYPE, SECURITY_TYPE, DELAY_TIME);

		// Install the logic unit to be tested in the elevator
		elevator.installLogicUnit(logicUnit);

		useCase = new Elevator_UseCaseScenario1(elevator);
		
		useCase.execute(elevator);
			
	}

}
