package views;


import java.awt.Color;
import java.awt.Graphics;
import interfaces.ElevatorWithDoorsSpecification;

public class JPanel_ElevatorWithDoors extends JPanel_ElevatorSpecification {


	/**
	 *  Generated automatically by Eclipse
	 */
	private static final long serialVersionUID = -5643995056148233187L;
	
	final Color DOOR_OPEN_COLOUR = BACKGROUND_COLOUR;
	final Color DOOR_CLOSED_COLOUR = JPanel_ColourConfiguration.DOOR_CLOSED_COLOUR;
	final int DOOR_HEIGHT =FLOOR_HEIGHT/3;
	final int DOOR_WIDTH =3;

	public JPanel_ElevatorWithDoors(ElevatorWithDoorsSpecification elevator, int animationTime) {
		
		super(elevator, animationTime);
	}
	
	@Override
	public void paintComponent(Graphics g){
		
		super.paintComponent(g);
	
		
		// Floors
					for (int floor = 0; floor< NUMBER_OF_FLOORS; floor++){
						
						// Doors at Floors
						
						g.setColor(DOOR_CLOSED_COLOUR);
						g.fillRect(	ELEVATOR_WIDTH-DOOR_WIDTH, HEIGHT - (FLOOR_HEIGHT*floor)-DOOR_HEIGHT, DOOR_WIDTH, DOOR_HEIGHT);
						g.setColor(DOOR_OPEN_COLOUR);
						if ( ((ElevatorWithDoorsSpecification) elevator).doorOpenAtFloor(floor) && step == 0)
							g.fillRect(	ELEVATOR_WIDTH-DOOR_WIDTH, HEIGHT - (FLOOR_HEIGHT*floor)-DOOR_HEIGHT, DOOR_WIDTH, DOOR_HEIGHT);
						
						// Floors
						g.setColor(FLOOR_COLOUR);
						g.fillRect(	ELEVATOR_WIDTH, HEIGHT - (FLOOR_HEIGHT*floor)-2, FLOOR_WIDTH, 2);
						g.drawString("Floor: "+floor, ELEVATOR_WIDTH, HEIGHT - (FLOOR_HEIGHT*floor)-5);
					}
	
	}

}
