package views;

import java.awt.BasicStroke;
import java.awt.Graphics;
import java.awt.Color;
import java.awt.Graphics2D;

import models.elevators.ElevatorWithLockableFloors;
import interfaces.ElevatorWithLockableFloorsSpecification;

public class JPanel_ElevatorWithLockableFloors extends JPanel_ElevatorSpecification{
	
	
	final Color LOCKED_FLOOR_COLOR = JPanel_ColourConfiguration.LOCKED_FLOOR_COLOR;
	final Color UNLOCKED_FLOOR_COLOR = JPanel_ColourConfiguration.UNLOCKED_FLOOR_COLOR;
	
	public JPanel_ElevatorWithLockableFloors(ElevatorWithLockableFloors elevator,int animationTime) {
		super(elevator, animationTime);
	}

	/**
	 * Generated automatically by Eclipse
	 */
	private static final long serialVersionUID = -8876093721704855003L;

	@Override
	public void paintComponent(Graphics g){
		
		super.paintComponent(g);
		
		for (int floor = 0; floor< NUMBER_OF_FLOORS; floor++){
			
			if ( ((ElevatorWithLockableFloorsSpecification) elevator).is_lockable(floor) ){
				

				
				if ( ((ElevatorWithLockableFloorsSpecification) elevator).is_locked(floor) )
					
					{g.setColor(LOCKED_FLOOR_COLOR);
		             g.drawString("Floor Locked", ELEVATOR_WIDTH, HEIGHT - (FLOOR_HEIGHT*floor)-25);}
			       else{ g.setColor(UNLOCKED_FLOOR_COLOR);
				     g.drawString("Floor UnLocked", ELEVATOR_WIDTH, HEIGHT - (FLOOR_HEIGHT*floor)-25);}
				
				if ( ((ElevatorWithLockableFloorsSpecification) elevator).is_locked(floor) && 
					 elevator.currentFloor() == previous_floor){
					Graphics2D g2 = (Graphics2D) g;
	                g2.setStroke(new BasicStroke(3));
				g.drawOval(20+ (BUTTON_HEIGHT_ON_FLOORS*floor),
						   HEIGHT - (elevator.currentFloor()*FLOOR_HEIGHT)- ELEVATOR_HEIGHT, 
						   BUTTON_HEIGHT_ON_FLOORS, BUTTON_HEIGHT_ON_FLOORS);
				}
			}
			
			
			
		}
	}

}
